package cz.muni.fi.lasaris.sbms.data.connectors;

import java.util.List;
import java.util.Properties;

import cz.muni.fi.lasaris.sbms.data.structures.Address;
import cz.muni.fi.lasaris.sbms.data.structures.AddressGroup;
import cz.muni.fi.lasaris.sbms.data.structures.AggregationFunction;
import cz.muni.fi.lasaris.sbms.data.structures.containers.Aggregation;
import cz.muni.fi.lasaris.sbms.data.structures.containers.Snapshot;
import cz.muni.fi.lasaris.sbms.data.structures.values.AggregatedValue;
import cz.muni.fi.lasaris.sbms.data.structures.values.RawValue;

public interface BASConnector {
	
	public void init(Properties props);
	public void close();
	
	public RawValue getDataPointValue(Address dataPoint);
	public RawValue getDataPointValue(Address dataPoint, boolean allowCache);
	public Snapshot getDataPointValues(List<Address> dataPoints);
	public Snapshot getDataPointValues(List<Address> dataPoints, boolean allowCache);
	
	// compute aggregation over group of data points
	public AggregatedValue getDataPointsAggregation(List<Address> dataPoints, AggregationFunction aggregation);
	public AggregatedValue getDataPointsAggregation(List<Address> dataPoints, AggregationFunction aggregation, boolean allowCache);
	
	// compute aggregations for each group of data points (equivalent to repeated call to getDataPointsAggregation)
	public Aggregation<AddressGroup> getDataPointGroupAggregations(List<AddressGroup> dataPointGroups, AggregationFunction aggregation);
	public Aggregation<AddressGroup> getDataPointGroupAggregations(List<AddressGroup> dataPointGroups, AggregationFunction aggregation, boolean allowCache);
	
}
