package cz.muni.fi.lasaris.sbms.data.connectors.plugins;

import cz.muni.fi.lasaris.sbms.data.structures.Address;

public class BACnetAddress {
	
	private int instance;
	private int property;
	private int device;
	private int type;
	
	public BACnetAddress(Address dataPoint) {
		String a = dataPoint.getId();
		String[] parts = a.split(".");
		device = Integer.parseInt(parts[0]);
		type = getType(parts[1]);
		instance = Integer.parseInt(parts[2]);
		if(parts.length > 3) {
			property = getProperty(parts[3]);
		} else {
			property = 85;
		}
	}

	private int getProperty(String string) {
		// TODO implement according to BACNet register
		return 85;
	}

	private int getType(String type) {
		int num = 0;
		switch(type) {
		case "AI" : 
			num = 0;
		break;
		case "AO":
			num = 1;
		break;
		case "AV":
			num = 2;
		break;
		case "BI":
			num = 3;
		break;
		case "BO":
			num = 4;
		break;
		case "BV":
			num = 5;
		break;
		case "CAL":
			num = 6;
		break;
		case "DEV":
			num = 8;
		break;
		case "EV":
			num = 9;
		break;
		case "CO":
			num = 12;
		break;
		case "MI":
			num = 13;
		break;
		case "MO":
			num = 14;
		break;
		case "EVC":
			num = 15;
		break;
		case "PG":
			num = 16;
		break;
		case "SCH":
			num = 17;
		break;
		case "MV":
			num = 19;
		break;
		case "TL":
			num = 20;
		break;
		case "EVL":
			num = 25;
		break;
		case "MT":
			num = 27;
		break;
		default:
		break;
		}
		return num;
	}

	public int getInstance() {
		return this.instance;
	}

	public int getProperty() {
		return this.property;
	}
	
	public int getType() {
		return this.type;
	}
	
	public int getDevice() {
		return this.device;
	}

}
